#ifndef __INPUTFRAME_HPP
#define __INPUTFRAME_HPP

#include <SophiaFramework.hpp>
#include "Dialoger.hpp"

SFMTYPEDEFRESPONDER(InputWindow)
class InputWindow : public SFZWindow {
    SFMSEALRESPONDER(InputWindow)
    SFMRESPONDERINSTANTIATEFOUR(InputWindow, SFZWindow, SFYContainer, SFYWidget, SFYResponder)
private:
    enum PlacementEnum {
        X_MARGIN = 5,
        Y_MARGIN = 5
    };
    SFMTYPEDEFTYPE(PlacementEnum)
    SFZSingleTextLabelControlSmp    _labelTitle;        // tB[h ^Cg x
    SFZSingleTextLabelControlSmp    _labelURL;          // tB[h URL x
    SFZSingleEditBoxControlSmp      _editboxTitle;      // tB[h ^Cg GfBbg{bNX
    SFZSingleEditBoxControlSmp      _editboxURL;        // tB[h URL GfBbg{bNX
    SFZTextButtonControlSmp         _buttonOK;          // o^ {^
    SFZTextButtonControlSmp         _buttonCancel;      // LZ {^
    DialogerPtr                     _dialoger;          // _CAO쐬wpNX
public:
    static  InputWindowSmp           NewInstance(SFCErrorPtr exception = null);
            SFCError                Make(Void);
            SFCError                CreateFeedTitle(SFXRectangleRef rectangle);
            SFCError                CreateFeedUrl(SFXRectangleRef rectangle);
            SFCError                CheckContents(Void);
private:
    explicit                        InputWindow(Void) static_throws;
    virtual                         ~InputWindow(Void);
            SFCError                SetSoftKey(Void);
    XANDLER_DECLARE_VOIDRESULT(OnFinish)                // _CAO OK {^̃nh
    XANDLER_DECLARE_BOOLEVENT(OnKey)                    // L[nh
    XANDLER_DECLARE_VOIDEVENT(OnSoftKey)                // \tgL[nh
};

#endif //__INPUTFRAME_HPP
