#ifndef __MAINWINDOW_HPP
#define __MAINWINDOW_HPP

#include <SophiaFramework.hpp>
#include "SubscriptionWindow.hpp"
#include "DetailWindow.hpp"
#include "RSSData.hpp"

SFMTYPEDEFRESPONDER(MainWindow)
class MainWindow : public SFZWindow {
    SFMSEALRESPONDER(MainWindow)
    SFMRESPONDERINSTANTIATEFOUR(MainWindow, SFZWindow, SFYContainer, SFYWidget, SFYResponder)
public:
    enum CodeEnum {
        CODE_TYPE = four_char_code('M', 'A', 'I', 'N')
    };
    SFMTYPEDEFTYPE(CodeEnum)
private:
    RSSFeedPtr                      _currentFeed;           // ݂ RSS tB[h
    SFZTitlePlainFrameSmp           _frame;                 // t[
    SFZWindowSmp                    _windowDesc;            // EBhE
    SFZMultipleTextLabelControlSmp  _labelCurDesc;          // ݂̐x
    SFZListBoxControlSmp            _listItemTitle;         // tB[hACeXg
    SubscriptionWindowSmp           _subscriptionWindow;    // tB[hǗEBhE
    DetailWindowSmp                 _detailWindow;          // ڍ׃EBhE
    SFZSoftKeyControlSmp            _soft;                  // \tgL[ EBhE
public:
    static  MainWindowSmp           NewInstance(SFCErrorPtr exception = null);
            SFCError                Make(Void);
            Void                    Update(Void);
private:
    explicit                        MainWindow(Void) static_throws;
    virtual                         ~MainWindow(Void);
            SFCError                CreateItemTitles(SFXRectangleRef rectangle);
            SFCError                CreateDescription(SFXRectangleRef rectangle);
            SFCError                CreateFrame(SFXWideStringConstRef title);
            SFCError                CreateSubscriptionWindow(Void);
            SFCError                CreateDetailWindow(Void);
            SFCError                SetSoftKey(Void);
            SFCError                SetText(SFXWideStringConstRef text);
    XANDLER_DECLARE_VOIDRESULT(OnSoftKey)                   // \tgL[ nh
    XANDLER_DECLARE_VOIDVALUE(OnListValue)                  // Xglnh
    XANDLER_DECLARE_VOIDRESULT(OnSelect)                    // XgInh
};

#endif //__MAINWINDOW_HPP
