#include "RSSData.hpp"
#include "rssreader_sfy.hpp"

// RSS  title  date Ȃ瓯̂Ƃ݂Ȃ
Bool operator==(RSSItemConstRef item1, RSSItemConstRef item2)
{
    return (item1.title == item2.title && item1.date == item2.date);
}

// RXgN^
RSSItem::RSSItem(SFXAnsiStringConstRef rsstitle, SFXAnsiStringConstRef rssdescription, SFXDateConstRef rssdate, Bool rssalreadyRead) :
    title(rsstitle),
    description(rssdescription),
    date(rssdate),
    alreadyRead(rssalreadyRead)
{
}

// RXgN^
RSSFeed::RSSFeed(SFXAnsiStringConstRef title, SFXAnsiStringConstRef url, SFXDateConstRef date) :
    _title(title),
    _url(url),
    _date(date)
{
}

// fXgN^
RSSFeed::~RSSFeed(Void)
{
    RSSItemPtr item;
    // Ce[^擾đSf[^폜B
    SFXList<RSSItemPtr>::Iterator itor(_itemList.GetFirstIterator());
    while(itor.HasNext()) {
        item = itor.GetNext();
        ::delete item;
    }
}

// RSS͂
SFCError RSSFeed::Parse(SFXAnsiStringConstRef xml)
{
    SFXXMLDOMParser parser;
    SFXXMLDocumentPtr root;
    SFXXMLNodePtr child;
    SFXAnsiString title;
    SFXAnsiString description;
    SFXDate date;
    RSSItemPtr item;
    SInt32 count = 0;
    SFXAnsiString temp;
    SFCError error;

    // XML ͂
    if ((error = parser.Parse(xml)) == SFERR_NO_ERROR) {
        if ((root = parser.GetDocument()) != null) { // [g擾
            // Item ^OT
            SFXList<SFXXMLNodePtr>* list = root->GetElementsByTagName("channel");
            if (list != null && list->GetSize() > 0) {
                child = list->Get(0);
                for (child = child->GetFirstChild(); child != null; child = child->GetNextSibling()) {
                    if (SFXAnsiString(child->GetNodeName()) == "title") {
                        temp = child->GetText();
                        if (_title.IsEmptyCString()) {
                            error = SFXTextEncoding::UTF8ToShiftJIS(temp, &_title);
                        }
                    }
                    else if (SFXAnsiString(child->GetNodeName()) == "dc:date") {
                        // ͂ētɕϊ
                        date.Parse("YYYY-MM-DD%Thh:mm:ss+",
                        child->GetText());
                    }
                    if (error != SFERR_NO_ERROR) {
                        break;
                    }
                }
                if (error == SFERR_NO_ERROR) {
                    SFXList<SFXXMLNodePtr>* list = root->GetElementsByTagName("item");
                    if (list != null && list->GetSize() > 0) {
                        for (SInt32 i = 0; i < (list->GetSize()); ++i) {
                            child = list->Get(i);
                            for (child = child->GetFirstChild() ; child != null; child = child->GetNextSibling()) {
                                // title ^OȂ
                                if (SFXAnsiString(child->GetNodeName()) == "title") {
                                    // m[h̃eLXg擾
                                    temp = child->GetText();
                                    // UTF-8  ShiftJIS ɕϊ
                                    error = SFXTextEncoding::UTF8ToShiftJIS(temp, &title);
                                }
                                // description ^OȂ
                                else if (SFXAnsiString(child->GetNodeName()) == "description") {
                                    // m[h̃eLXg擾
                                    temp = child->GetText();
                                    // UTF-8  ShiftJIS ɕϊ
                                    error = SFXTextEncoding::UTF8ToShiftJIS(temp, &description);
                                }
                                // dc: date ^OȂ
                                else if (SFXAnsiString(child->GetNodeName()) == "dc: date") {
                                    // ͂ētɕϊ
                                    date.Parse("YYYY-MM-DD%Thh:mm:ss+",
                                    child->GetText());
                                }
                                if (error != SFERR_NO_ERROR) {
                                    break;
                                }
                            }
                            if ((item = ::new RSSItem(title, description, date)) != null) {
                                // dȂȂ
                                if (!Find(*item)) {
                                    // vf}
                                    if ((error = _itemList.Insert(count, item)) == SFERR_NO_ERROR) {
                                        ++count;
                                    }
                                    else {
                                        ::delete item;
                                    }
                                }
                                else {
                                    ::delete item;
                                }
                            }
                            else {
                                error = SFERR_NO_MEMORY;
                            }
                        }
                    }
                    else {
                        error = SFERR_FAILED;
                    }
                }
            }
            else {
                error = SFERR_FAILED;
            }
        }
    }
    if (error == SFERR_NO_ERROR) {
        // t@Cɕۑ
        error = RSSFeed::SaveToFile();
    }
    // G[
    else {
        _title = "͎s";
    }
    SFXHelper::dbgprintf("[SGXAWSParser] ParseXML END %d", error);
    return error;
}

// t@Cɕۑ
// f[^̎dl͈ȉ̒ʂ
// EPsłPRSS item \B
// ERSS item ̊e\vf DELIMITER_STR ŋ؂
//   DELIMITER_STR  <> ̏ꍇAPs title<>description<>topic<>date<>alreadyRead\r\nƂȂB
//   dateUInt32ŕ\́AalreadyRead  true Ȃ 1 Afalse Ȃ 0 Ƃ
SFCError RSSFeed::SaveToFile(Void)
{
    SFCError error;
    SFXPath temp;
    SFXFile file;
    SFXAnsiStringStreamWriter writer;
    RSSItemPtr item;
    SFXPath filename(DIRECTORY_NAME + _filename);

    // ꎞۑ̂߂̃pX擾
    if ((error = SFXFile::GetTemporaryPath(DIRECTORY_PATH, &temp)) == SFERR_NO_ERROR) {
        bool exists;
        error = SFXFile::Exists(temp, &exists);
        if (exists == false) {
            error = file.Create(temp,true);
        }
        if (error == SFERR_NO_ERROR) {
            // t@CJ
            if ((error = file.OpenReadWrite(temp)) == SFERR_NO_ERROR) {
                // ݃Xg[擾
                if ((error = file.GetStreamWriter(4096, &writer)) == SFERR_NO_ERROR) {
                    SFXList<RSSItemPtr>::Iterator itor(_itemList.GetFirstIterator());
                    while (itor.HasNext()) {
                        // ef[^t@Cɏo
                        // Ce[^擾
                        item = itor.GetNext();
                        // t@Cɏo
                        writer << item->title << DELIMITER_STR
                        << item->description  << DELIMITER_STR
                        << SFXAnsiString::Format("%u", item->date.AsUInt32()) << DELIMITER_STR
                        << ((item->alreadyRead) ? "1" : "0")
                        << "\r\n";
                        // ̊֐Ă΂ȂƎۂɃt@Cɏ܂Ȃ
                        writer.Flush();
                    }
                }
                file.Close();
            }
        }
    }
    if (error == SFERR_NO_ERROR) {
        // t@C폜
        SFXFile::Remove(filename);
        // t@CύX
        error = SFXFile::Rename(temp, filename);
    }
    return error;
}

// t@Cf[^ǂݏoB
// f[^̎dl SaveToFile ֐̃Rgɏ]B
Void RSSFeed::LoadFromFile(Void)
{
    SFCError error;
    SFXFile file;
    SFXAnsiStringStreamReader reader;
    SFXAnsiString string;
    SFXPath path(DIRECTORY_NAME + _filename);
    UInt32 size;

    // t@CTCY̎擾
    SFXFile::GetSize(path, &size);
    // t@CI[v
    error = file.OpenReadOnly(path);
    // t@CI[vɐȂ
    if (error == SFERR_NO_ERROR) {
        // ǂݎXg[擾
        error = file.GetStreamReader(size + 1, &reader);
        if (error == SFERR_NO_ERROR) {
            // t@Cǂݎ
            reader.Fetch();
            // string Ɋi[
            reader.ReadSFXAnsiString(&string);
            SInt32 c1 = 0;
            SInt32 c2, c3, c4, c5;
            while (true) {
                // s̍ŏ̋؂T
                c2 = string.FirstIndexOf(DELIMITER_STR, c1);
                // ȂsȂ̂ŏI
                if (c2 < 0) {
                    break;
                }
                c3 = string.FirstIndexOf(DELIMITER_STR, c2 + 1);
                c4 = string.FirstIndexOf(DELIMITER_STR, c3 + 1);
                c5 = string.FirstIndexOf('\n', c4) + 1;
                SFXAnsiString dateNumber = string.Substring(c3+ DELIMITER_LEN, c4);
                SFXDate date;
                // ͐Ŋi[Ă̂ŁA荞
                date.Set(dateNumber.AsUInt32());
                RSSItemPtr item = ::new RSSItem(string.Substring(c1, c2),
                string.Substring(c2 + DELIMITER_LEN, c3),
                date,
                string.Substring(c4 + DELIMITER_LEN, c5).Trim() == "1");
                // Xgɉ
                if (_itemList.InsertLast(item) != SFERR_NO_ERROR) {
                    ::delete item;
                    break;
                }
                c1 = c5;
            }
        }
        file.Close();
    }
    return;
}

// item Ɠf[^邩ǂTBȂ true Ԃ
Bool RSSFeed::Find(RSSItemConstRef item)
{
    // Ce[^擾
    SFXList<RSSItemPtr>::Iterator itor(_itemList.GetFirstIterator());

    while(itor.HasNext()) {
        RSSItemPtr item2 = itor.GetNext();
        if (item == *item2) {
            // 2RSSf[^Ȃ
            return true;
        }
    }
    return false;
}

// fXgN^
RSSFeedList::~RSSFeedList(Void)
{
    RSSFeedPtr feed;

    // Ce[^擾đSf[^폜
    SFXArray<RSSFeedPtr>::Iterator itor = _feedArray.GetFirstIterator();
    while(itor.HasNext()) {
        feed = itor.GetNext();
        ::delete feed;
    }
    return;
}

// RSS tB[hǉ
// ǉɐȂ true Ԃ
// feed itemList ̃t@CVɐݒ肷
Bool RSSFeedList::Add(RSSFeedPtr feed)
{
    SFXAnsiString filename, temp;
    SFXLCGRandom rand;
    if (feed != null) {
        filename = feed->_title;
        filename += feed->_url;
        // Ńt@CdȂ悤ɂB
        filename += SFXAnsiString::Format("%d", rand.GetUInt32() % 1000);
        // MD5ƂAt@C_ɂȂ悤ɂ
        SFXMailUtility::GetMD5(filename, &temp, true);
        // t@C16ƂB
        temp.SetLength(16);
        feed->SetFilename(temp);
        // ǉɐ true ԂB
        return _feedArray.InsertLast(feed) == SFERR_NO_ERROR;
    }
    return false;
}

// Xg index Ԗڂ̍ڂ폜
Void RSSFeedList::Delete(SIntN index)
{
    SFXAnsiString filename;

    // Xg̋L^폜
    _feedArray.Remove(index);
    // ̋L^̃t@C폜
    filename = _feedArray[index]->GetFilename();
    SFXFile::Remove(SFXPath(DIRECTORY_NAME + filename));
    return;
}

// t@Cɕۑ
// f[^̎dl͈ȉ̒ʂ
// EPsłPRSS feed \
// ERSS feed ̊e\vf DELIMITER_STR ŋ؂
//   DELIMITER_STR  <> ̏ꍇAPs filename<>title<>url<>date\r\n ƂȂB
//   dateUInt32ŕ\̂ł
SFCError RSSFeedList::SaveToFile(Void)
{
    SFXPath temp;
    SFXPath filename(DIRECTORY_NAME LIST_FILE_NAME);
    SFXFile file;
    SFXAnsiStringStreamWriter writer;
    SFCError error;
    SInt32 i;
    // ꎞۑ̂߂̃pX擾
    error = SFXFile::GetTemporaryPath(DIRECTORY_PATH, &temp);
    if (error == SFERR_NO_ERROR) {
        error = file.OpenReadWrite(temp);
        if (error == SFERR_NO_ERROR) {
            file.GetStreamWriter(4096, &writer);
            if (error == SFERR_NO_ERROR) {
                for (i = 0 ; i < _feedArray.GetSize() ; ++i) {
                    //t@Cɏo
                    writer << _feedArray[i]->GetFilename() << DELIMITER_STR <<
                    _feedArray[i]->_title << DELIMITER_STR
                    << _feedArray[i]->_url << DELIMITER_STR
                    << SFXAnsiString::Format("%u",
                    _feedArray[i]->_date.AsUInt32())
                    << "\r\n";
                    writer.Flush();
                }
            }
            file.Close();
        }
    }
    if (error == SFERR_NO_ERROR) {
        SFXFile::Remove(filename);
        error = SFXFile::Rename(temp, filename);
    }
    return error;
}

// t@CǂݏoB
// f[^̎dl SaveToFile ɏ]B
Void RSSFeedList::LoadFromFile(Void)
{
    SFCError error;
    SFXFile file;
    SFXAnsiStringStreamReader reader;
    SFXAnsiString string;
    SFXPath path(DIRECTORY_NAME LIST_FILE_NAME);
    UInt32 size;

    // t@CTCY̎擾
    SFXFile::GetSize(path, &size);
    // t@CI[vɐȂ
    if ((error = file.OpenReadOnly(path)) == SFERR_NO_ERROR) {
        if ((error = file.GetStreamReader(size + 1, &reader)) == SFERR_NO_ERROR) {
            reader.Fetch();
            // t@CSf[^ǂݏoB
            reader.ReadSFXAnsiString(&string);
            SInt32 c1 = 0;
            SInt32 c2, c3, c4, c5;
            while (true) {
                // s̍ŏ̃f~^T
                c2 = string.FirstIndexOf(DELIMITER_STR, c1);
                // ȂsȂ̂ŏI
                if (c2 < 0) {
                    break;
                }
                c3 = string.FirstIndexOf(DELIMITER_STR, c2 + 1);
                c4 = string.FirstIndexOf(DELIMITER_STR, c3 + 1);
                c5 = string.FirstIndexOf('\n', c4) + 1;
                SFXAnsiString dateNumber(string.Substring(c4 + DELIMITER_LEN, c5).Trim());
                SFXDate date;
                date.Set(dateNumber.AsUInt32());
                RSSFeedPtr feed = ::new RSSFeed(
                    string.Substring(c2 + DELIMITER_LEN, c3),
                    string.Substring(c3 + DELIMITER_LEN, c4), date
                );
                // ǉɐȂ
                if (Add(feed)) {
                    SFXAnsiString filename(string.Substring(c1, c2));
                    feed->SetFilename(filename);
                    feed->LoadFromFile();
                }
                else {
                    ::delete feed;
                    break;
                }
                c1 = c5;
            }
        }
        file.Close();
    }
    return;
}
