#ifndef __RSSDATA_HPP
#define __RSSDATA_HPP

#include <SophiaFramework.hpp>

#define DELIMITER_STR       "<>"
#define DELIMITER_LEN       (2)
#define DIRECTORY_NAME      "/data/"
#define DIRECTORY_PATH      (SFXPath(DIRECTORY_NAME))
#define LIST_FILE_NAME      "list.txt"

// RSS ACe
SFMTYPEDEFSTRUCT(RSSItem)
struct RSSItem {
    SFXAnsiString                   title;          // ^Cg
    SFXAnsiString                   description;    // 
    SFXDate                         date;           // tSFXDate`Ŋi[
    Bool                            alreadyRead;    // (true: / false:)
    RSSItem(SFXAnsiStringConstRef rsstitle,
        SFXAnsiStringConstRef rssdescription,
        SFXDateConstRef rssdate,
        Bool rssalreadyRead = false);
};

// RSS tB[h
SFMTYPEDEFCLASS(RSSFeed)
class RSSFeed {
public:
    SFXAnsiString                   _title;         // TCg̃^Cg
    SFXAnsiString                   _url;           // TCg URL
    SFXDate                         _date;          // ŏIXV
private:
    SFXAnsiString                   _filename;      // RSS ۑt@C
    SFXList<RSSItemPtr>             _itemList;      //  RSS ACeۑ
public:
                                    RSSFeed(SFXAnsiStringConstRef title, SFXAnsiStringConstRef url,
                                        SFXDateConstRef date = SFXDate());
                                    ~RSSFeed(Void);
    SFCError                        Parse(SFXAnsiStringConstRef xml);
    SFCError                        SaveToFile(Void);
    Void                            LoadFromFile(Void);
    Bool                            Find(RSSItemConstRef item);
    inline Void                     SetItem(SInt32 index, RSSItemPtr item)      { _itemList.Set(index, item); }
    inline RSSItemPtr               GetItem(SInt32 index)                       { return _itemList.Get(index); }
    inline SFXAnsiStringConstRef    GetFilename(Void)                           { return _filename; }
    inline Void                     SetFilename(SFXAnsiStringConstRef filename) { _filename = filename; }
    inline SInt32                   GetSize(Void)                               { return _itemList.GetSize(); }
    friend class                    RSSFeedList;
};

//  RSS tB[hi[AǗ邽߂̃NX
SFMTYPEDEFCLASS(RSSFeedList)
class RSSFeedList {
private:
    SFXArray<RSSFeedPtr>             _feedArray;    //  RSS tB[hۑ
public:
                                    ~RSSFeedList(Void);
    Bool                            Add(RSSFeedPtr feed);
    Void                            Delete(SIntN index);
    SFCError                        SaveToFile(Void);
    Void                            LoadFromFile(Void);
    inline SInt32                   GetSize(Void)                               { return _feedArray.GetSize(); }
    inline SInt32                   FirstIndexOf(RSSFeedPtr item)               { return _feedArray.FirstIndexOf(item); }
    RSSFeedPtr                      operator[](SInt32 index)                    { return _feedArray[index]; }
};

#endif //__RSSDATA_HPP
