#ifndef __SUBSCRIPTIONWINDOW_HPP
#define __SUBSCRIPTIONWINDOW_HPP

#include <SophiaFramework.hpp>
#include "InputWindow.hpp"
#include "Dialoger.hpp"

SFMTYPEDEFRESPONDER(SubscriptionWindow)
class SubscriptionWindow : public SFZWindow {
    SFMSEALRESPONDER(SubscriptionWindow)
    SFMRESPONDERINSTANTIATEFOUR(SubscriptionWindow, SFZWindow, SFYContainer, SFYWidget, SFYResponder)
public:
    enum CodeEnum {
        CODE_TYPE = four_char_code('S', 'U', 'B', 'S')
    };
    SFMTYPEDEFTYPE(CodeEnum)
private:
    SInt32                          _cursor;                // J[\̈ʒu
    SFXHTTPConnection               _http;                  // HTTP ʐM̂߂̃NX
    SFXAnsiStringStreamReader       _reader;                // ݎM̃f[^
    SFXAnsiString                   _xml;                   // ܂łɎM XML f[^
    SFZWindowSmp                    _windowURL;             // URL EBhE
    SFZMultipleTextLabelControlSmp  _labelURL;              // URL x
    SFZListBoxControlSmp            _listURL;               // tB[h URL Xg
    DialogerPtr                     _dialoger;              // _CAO
    SFZTitlePlainFrameSmp           _frame;                 // t[
    InputWindowSmp                  _inputWindow;           // tB[hǉEBhE
    SFZSoftKeyControlSmp            _soft;                  // \tgL[ EBhE
public:
                                    SubscriptionWindow(Void) static_throws;
    virtual                         ~SubscriptionWindow(Void);
    static  SubscriptionWindowSmp   NewInstance(SFCErrorPtr exception = null);
            SFCError                Make(Void);
            Void                    Update(Void);
private:
            SFCError                SetSoftKey(Void);
            SFCError                CreateFeedList(SFXRectangleRef rectangle);
            SFCError                CreateUrlWindow(SFXRectangleRef rectangle);
            SFCError                CreateFrame(Void);
            SFCError                CreateInputWindow(Void);
            SFCError                MakeMenu(Void);
    XANDLER_DECLARE_BOOLEVENT(OnKey)                        // L[nh
    XANDLER_DECLARE_VOIDRESULT(OnSoftKey)                   // \tgL[ nh
    XANDLER_DECLARE_VOIDRESULT(OnConnect)                   // ڑmF_CAO nh
    XANDLER_DECLARE_VOIDRESULT(OnConnecting)                // ʐMInh
    XANDLER_DECLARE_VOIDRESULT(OnDelete)                    // tB[h폜nh
    XANDLER_DECLARE_VOIDVALUE(OnListValue)                  // tB[hꗗnh
    XANDLER_DECLARE_VOIDRESULT(OnSelect)                    // tB[hꗗInh
    XANDLER_DECLARE_VOIDRESULT(OnMenuResult)                // j[ʃnh
    XANDLER_DECLARE_VOIDSTATE(OnInputWindowValid)           // ̓EBhE̗Lԃnh
    XALLBACK_DECLARE_SFXHTTPCONNECTION(ConnectCallback)     // HTTP ڑJnR[obN
    XALLBACK_DECLARE_SFXBINARYSTREAMREADER(FetchCallback)   // HTTP MR[obN
};

#endif //__SUBSCRIPTIONWINDOW_HPP
